diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/qos-txop.cc ns-3.34/src/wifi/model/qos-txop.cc
--- ns-3.33/src/wifi/model/qos-txop.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/qos-txop.cc	2021-07-14 10:31:07.000000000 -0700
@@ -1485,37 +671,6 @@
 }
 
 void
-QosTxop::GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient, double rxSnr, double dataSnr, WifiTxVector dataTxVector)
-{
-  NS_LOG_FUNCTION (this << blockAck << recipient << rxSnr << dataSnr << dataTxVector);
-  NS_LOG_DEBUG ("got block ack from=" << recipient);
-  m_baManager->NotifyGotBlockAck (blockAck, recipient, rxSnr, dataSnr, dataTxVector);
-  if (!m_txOkCallback.IsNull ())
-    {
-      m_txOkCallback (m_currentHdr);
-    }
-  m_currentPacket = 0;
-  ResetCw ();
-}
-
-bool QosTxop::GetAmpduExist (Mac48Address dest) const
-{
-  NS_LOG_FUNCTION (this << dest);
-  auto it = m_aMpduEnabled.find (dest);
-  if (it != m_aMpduEnabled.end ())
-    {
-      return it->second;
-    }
-  return false;
-}
-
-void QosTxop::SetAmpduExist (Mac48Address dest, bool enableAmpdu)
-{
-  NS_LOG_FUNCTION (this << dest << enableAmpdu);
-  m_aMpduEnabled[dest] = enableAmpdu;
-}
-
-void
 QosTxop::CompleteMpduTx (Ptr<WifiMacQueueItem> mpdu)
 {
   NS_ASSERT (mpdu->GetHeader ().IsQosData ());
@@ -1526,35 +681,6 @@
     }
 }
 
-bool
-QosTxop::SetupBlockAckIfNeeded (void)
-{
-  NS_LOG_FUNCTION (this);
-  uint8_t tid = m_currentHdr.GetQosTid ();
-  Mac48Address recipient = m_currentHdr.GetAddr1 ();
-  uint32_t packets = m_queue->GetNPacketsByTidAndAddress (tid, recipient);
-  if ((GetBlockAckThreshold () > 0 && packets >= GetBlockAckThreshold ())
-      || (GetLow ()->GetMpduAggregator () != 0 && GetLow ()->GetMpduAggregator ()->GetMaxAmpduSize (recipient, tid, WIFI_MOD_CLASS_HT) > 0 && packets > 1)
-      || m_stationManager->GetVhtSupported ()
-      || m_stationManager->GetHeSupported ())
-    {
-      /* Block ack setup */
-      uint16_t startingSequence = m_txMiddle->GetNextSeqNumberByTidAndAddress (tid, recipient);
-      SendAddBaRequest (recipient, tid, startingSequence, m_blockAckInactivityTimeout, true);
-      return true;
-    }
-  return false;
-}
-
-void
-QosTxop::CompleteConfig (void)
-{
-  NS_LOG_FUNCTION (this);
-  m_baManager->SetTxMiddle (m_txMiddle);
-  m_low->RegisterEdcaForAc (m_ac, this);
-  m_baManager->SetBlockAckInactivityCallback (MakeCallback (&QosTxop::SendDelbaFrame, this));
-}
-
 void
 QosTxop::SetBlockAckThreshold (uint8_t threshold)
 {
@@ -1577,102 +703,10 @@
   return m_blockAckThreshold;
 }
 
-void
-QosTxop::SendAddBaRequest (Mac48Address dest, uint8_t tid, uint16_t startSeq,
-                           uint16_t timeout, bool immediateBAck)
-{
-  NS_LOG_FUNCTION (this << dest << +tid << startSeq << timeout << immediateBAck);
-  NS_LOG_DEBUG ("sent ADDBA request to " << dest);
-  WifiMacHeader hdr;
-  hdr.SetType (WIFI_MAC_MGT_ACTION);
-  hdr.SetAddr1 (dest);
-  hdr.SetAddr2 (m_low->GetAddress ());
-  hdr.SetAddr3 (m_low->GetBssid ());
-  hdr.SetDsNotTo ();
-  hdr.SetDsNotFrom ();
-
-  WifiActionHeader actionHdr;
-  WifiActionHeader::ActionValue action;
-  action.blockAck = WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST;
-  actionHdr.SetAction (WifiActionHeader::BLOCK_ACK, action);
-
-  Ptr<Packet> packet = Create<Packet> ();
-  /*Setting ADDBARequest header*/
-  MgtAddBaRequestHeader reqHdr;
-  reqHdr.SetAmsduSupport (true);
-  if (immediateBAck)
-    {
-      reqHdr.SetImmediateBlockAck ();
-    }
-  else
-    {
-      reqHdr.SetDelayedBlockAck ();
-    }
-  reqHdr.SetTid (tid);
-  /* For now we don't use buffer size field in the ADDBA request frame. The recipient
-   * will choose how many packets it can receive under block ack.
-   */
-  reqHdr.SetBufferSize (0);
-  reqHdr.SetTimeout (timeout);
-  reqHdr.SetStartingSequence (startSeq);
-
-  m_baManager->CreateAgreement (&reqHdr, dest);
-
-  packet->AddHeader (reqHdr);
-  packet->AddHeader (actionHdr);
-
-  m_currentPacket = packet;
-  m_currentHdr = hdr;
-
-  uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor (&m_currentHdr);
-  m_currentHdr.SetSequenceNumber (sequence);
-  m_stationManager->UpdateFragmentationThreshold ();
-  m_currentHdr.SetFragmentNumber (0);
-  m_currentHdr.SetNoMoreFragments ();
-  m_currentHdr.SetNoRetry ();
-
-  m_currentParams.EnableAck ();
-  m_currentParams.DisableRts ();
-  m_currentParams.DisableNextData ();
-
-  m_low->StartTransmission (Create<WifiMacQueueItem> (m_currentPacket, m_currentHdr), m_currentParams, this);
-}
-
-void
-QosTxop::SendDelbaFrame (Mac48Address addr, uint8_t tid, bool byOriginator)
+uint16_t
+QosTxop::GetBlockAckInactivityTimeout (void) const
 {
-  NS_LOG_FUNCTION (this << addr << +tid << byOriginator);
-  WifiMacHeader hdr;
-  hdr.SetType (WIFI_MAC_MGT_ACTION);
-  hdr.SetAddr1 (addr);
-  hdr.SetAddr2 (m_low->GetAddress ());
-  hdr.SetAddr3 (m_low->GetBssid ());
-  hdr.SetDsNotTo ();
-  hdr.SetDsNotFrom ();
-
-  MgtDelBaHeader delbaHdr;
-  delbaHdr.SetTid (tid);
-  if (byOriginator)
-    {
-      delbaHdr.SetByOriginator ();
-      m_baManager->DestroyAgreement (addr, tid);
-    }
-  else
-    {
-      delbaHdr.SetByRecipient ();
-      m_low->DestroyBlockAckAgreement (addr, tid);
-    }
-
-  WifiActionHeader actionHdr;
-  WifiActionHeader::ActionValue action;
-  action.blockAck = WifiActionHeader::BLOCK_ACK_DELBA;
-  actionHdr.SetAction (WifiActionHeader::BLOCK_ACK, action);
-
-  Ptr<Packet> packet = Create<Packet> ();
-  packet->AddHeader (delbaHdr);
-  packet->AddHeader (actionHdr);
-
-  PushFront (packet, hdr);
+  return m_blockAckInactivityTimeout;
 }
 
 void
@@ -1680,31 +714,10 @@
 {
   NS_LOG_FUNCTION (this);
   ResetCw ();
-  m_cwTrace = GetCw ();
   GenerateBackoff ();
 }
 
 void
-QosTxop::BaTxOk (const WifiMacHeader &hdr)
-{
-  NS_LOG_FUNCTION (this << hdr);
-  if (!m_txOkCallback.IsNull ())
-    {
-      m_txOkCallback (m_currentHdr);
-    }
-}
-
-void
-QosTxop::BaTxFailed (const WifiMacHeader &hdr)
-{
-  NS_LOG_FUNCTION (this << hdr);
-  if (!m_txFailedCallback.IsNull ())
-    {
-      m_txFailedCallback (m_currentHdr);
-    }
-}
-
-void
 QosTxop::AddBaResponseTimeout (Mac48Address recipient, uint8_t tid)
 {
   NS_LOG_FUNCTION (this << recipient << +tid);
@@ -1714,7 +727,10 @@
       m_baManager->NotifyAgreementNoReply (recipient, tid);
       Simulator::Schedule (m_failedAddBaTimeout, &QosTxop::ResetBa, this, recipient, tid);
       GenerateBackoff ();
-      RestartAccessIfNeeded ();
+      if (HasFramesToTransmit () && m_access == NOT_REQUESTED)
+        {
+          m_channelAccessManager->RequestAccess (this);
+        }
     }
 }
 
@@ -1765,4 +781,10 @@
   return true;
 }
 
+AcIndex
+QosTxop::GetAccessCategory (void) const
+{
+  return m_ac;
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/qos-txop.h ns-3.34/src/wifi/model/qos-txop.h
--- ns-3.33/src/wifi/model/qos-txop.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/qos-txop.h	2021-07-14 10:31:07.000000000 -0700
@@ -28,10 +28,6 @@
 #include "txop.h"
 #include "qos-utils.h"
 
-class AmpduAggregationTest;
-class TwoLevelAggregationTest;
-class HeAggregationTest;
-
 namespace ns3 {
 
 class QosBlockedDestinations;
@@ -39,22 +35,8 @@
 class MgtDelBaHeader;
 class AggregationCapableTransmissionListener;
 class WifiTxVector;
-class WifiAckPolicySelector;
-
-/**
- * Enumeration for type of station
- */
-enum TypeOfStation
-{
-  STA,
-  AP,
-  ADHOC_STA,
-  MESH,
-  HT_STA,
-  HT_AP,
-  HT_ADHOC_STA,
-  OCB
-};
+class QosFrameExchangeManager;
+class WifiTxParameters;
 
 /**
  * \brief Handle packet fragmentation and retransmissions for QoS data frames as well
@@ -92,15 +74,6 @@
 class QosTxop : public Txop
 {
 public:
-  /// allow AmpduAggregationTest class access
-  friend class ::AmpduAggregationTest;
-  /// allow TwoLevelAggregationTest class access
-  friend class ::TwoLevelAggregationTest;
-  /// allow HeAggregationTest class access
-  friend class ::HeAggregationTest;
-
-  std::map<Mac48Address, bool> m_aMpduEnabled; //!< list containing flags whether A-MPDU is enabled for a given destination address
-
   /**
    * \brief Get the type ID.
    * \return the object TypeId
@@ -110,50 +83,35 @@
   QosTxop ();
   virtual ~QosTxop ();
 
-  // Overridden from Txop
-  bool IsQosTxop (void) const;
-  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager);
-  virtual bool HasFramesToTransmit (void);
-  void NotifyAccessGranted (void);
-  void NotifyInternalCollision (void);
-  void GotAck (void);
-  void GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient,
-                    double rxSnr, double dataSnr, WifiTxVector dataTxVector);
-  void MissedBlockAck (uint8_t nMpdus);
-  void MissedAck (void);
-  void StartNextPacket (void);
-  void EndTxNoAck (void);
-  void RestartAccessIfNeeded (void);
-  void StartAccessIfNeeded (void);
-  Time GetTxopRemaining (void) const;
-  bool NeedFragmentation (void) const;
-  Ptr<Packet> GetFragmentPacket (WifiMacHeader *hdr);
+  bool IsQosTxop (void) const override;
+  AcIndex GetAccessCategory (void) const override;
+  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager) override;
+  bool HasFramesToTransmit (void) override;
+  void NotifyInternalCollision (void) override;
+  void NotifyChannelAccessed (Time txopDuration) override;
+  void NotifyChannelReleased (void) override;
+  void SetDroppedMpduCallback (DroppedMpdu callback) override;
 
   /**
-   * Set the ack policy selector.
+   * Set the Frame Exchange Manager associated with this QoS STA.
    *
-   * \param ackSelector the ack policy selector.
+   * \param qosFem the associated QoS Frame Exchange Manager.
    */
-  void SetAckPolicySelector (Ptr<WifiAckPolicySelector> ackSelector);
-  /**
-   * Return the ack policy selector.
-   *
-   * \return the ack policy selector.
-   */
-  Ptr<WifiAckPolicySelector> GetAckPolicySelector (void) const;
+  void SetQosFrameExchangeManager (const Ptr<QosFrameExchangeManager> qosFem);
+
   /**
-   * Set type of station with the given type.
+   * Return true if an explicit BlockAckRequest is sent after a missed BlockAck
    *
-   * \param type the type of station.
+   * \return true if an explicit BlockAckRequest is sent after a missed BlockAck
    */
-  void SetTypeOfStation (TypeOfStation type);
+  bool UseExplicitBarAfterMissedBlockAck (void) const;
+
   /**
-   * Return type of station.
+   * Get the Block Ack Manager associated with this QosTxop.
    *
-   * \return type of station.
+   * \returns the Block Ack Manager
    */
-  TypeOfStation GetTypeOfStation (void) const;
-
+  Ptr<BlockAckManager> GetBaManager (void);
   /**
    * \param address recipient address of the peer station
    * \param tid traffic ID.
@@ -186,9 +144,28 @@
    */
   uint16_t GetBaStartingSequence (Mac48Address address, uint8_t tid) const;
   /**
-   * \param address recipient address
+   * \param recipient MAC address of recipient
    * \param tid traffic ID
    *
+   * \return the type of Block Ack Requests sent to the recipient
+   *
+   * This function returns the type of Block Ack Requests sent to the recipient.
+   */
+  BlockAckReqType GetBlockAckReqType (Mac48Address recipient, uint8_t tid) const;
+  /**
+   * \param recipient MAC address
+   * \param tid traffic ID
+   *
+   * \return the type of Block Acks sent by the recipient
+   *
+   * This function returns the type of Block Acks sent by the recipient.
+   */
+  BlockAckType GetBlockAckType (Mac48Address recipient, uint8_t tid) const;
+  /**
+   * \param recipient Address of recipient.
+   * \param tid traffic ID.
+   * \return the BlockAckRequest to send
+   *
    * Prepare a BlockAckRequest to be sent to <i>recipient</i> for Traffic ID
    * <i>tid</i>. The header for the BlockAckRequest is requested to the QosTxop
    * corresponding to the given TID. A block ack agreement with the given recipient
@@ -206,13 +183,6 @@
 
   /* Event handlers */
   /**
-   * Event handler when a CTS timeout has occurred.
-   *
-   * \param mpduList the list of MPDUs that were not transmitted
-   */
-  void NotifyMissedCts (std::list<Ptr<WifiMacQueueItem>> mpduList);
-
-  /**
    * Event handler when an ADDBA response is received.
    *
    * \param respHdr ADDBA response header.
@@ -226,14 +196,20 @@
    * \param recipient address of the recipient.
    */
   void GotDelBaFrame (const MgtDelBaHeader *delBaHdr, Mac48Address recipient);
-
   /**
-   * Check if BlockAckRequest should be re-transmitted.
+   * Callback when ADDBA response is not received after timeout.
+   *
+   * \param recipient MAC address of recipient
+   * \param tid traffic ID
+   */
+  void AddBaResponseTimeout (Mac48Address recipient, uint8_t tid);
+  /**
+   * Reset BA agreement after BA negotiation failed.
    *
-   * \return true if BAR should be re-transmitted,
-   *         false otherwise.
+   * \param recipient MAC address of recipient
+   * \param tid traffic ID
    */
-  bool NeedBarRetransmission (void);
+  void ResetBa (Mac48Address recipient, uint8_t tid);
 
   /**
    * Set the access category of this EDCAF.
@@ -252,11 +228,6 @@
   void PushFront (Ptr<const Packet> packet, const WifiMacHeader &hdr);
 
   /**
-   * Complete block ack configuration.
-   */
-  void CompleteConfig (void);
-
-  /**
    * Set threshold for block ack mechanism. If number of packets in the
    * queue reaches the threshold, block ack mechanism is used.
    *
@@ -277,14 +248,11 @@
    */
   void SetBlockAckInactivityTimeout (uint16_t timeout);
   /**
-   * Sends DELBA frame to cancel a block ack agreement with STA
-   * addressed by <i>addr</i> for TID <i>tid</i>.
+   * Get the BlockAck inactivity timeout.
    *
-   * \param addr address of the recipient.
-   * \param tid traffic ID.
-   * \param byOriginator flag to indicate whether this is set by the originator.
+   * \return the BlockAck inactivity timeout.
    */
-  void SendDelbaFrame (Mac48Address addr, uint8_t tid, bool byOriginator);
+  uint16_t GetBlockAckInactivityTimeout (void) const;
   /**
    * Stores an MPDU (part of an A-MPDU) in block ack agreement (i.e. the sender is waiting
    * for a BlockAck containing the sequence number of this MPDU).
@@ -293,20 +261,6 @@
    */
   void CompleteMpduTx (Ptr<WifiMacQueueItem> mpdu);
   /**
-   * Return whether A-MPDU is used to transmit data to a peer station.
-   *
-   * \param dest address of peer station
-   * \returns true if A-MPDU is used by the peer station
-   */
-  bool GetAmpduExist (Mac48Address dest) const;
-  /**
-   * Set indication whether A-MPDU is used to transmit data to a peer station.
-   *
-   * \param dest address of peer station.
-   * \param enableAmpdu flag whether A-MPDU is used or not.
-   */
-  void SetAmpduExist (Mac48Address dest, bool enableAmpdu);
-  /**
    * Set the timeout to wait for ADDBA response.
    *
    * \param addBaResponseTimeout the timeout to wait for ADDBA response
@@ -361,116 +315,89 @@
    * \param recipient the receiver station address.
    * \returns the peeked frame.
    */
-  Ptr<const WifiMacQueueItem> PeekNextFrame (uint8_t tid = 8, Mac48Address recipient = Mac48Address::GetBroadcast ());
+  Ptr<const WifiMacQueueItem> PeekNextMpdu (uint8_t tid = 8,
+                                            Mac48Address recipient = Mac48Address::GetBroadcast ());
   /**
-   * Dequeue the frame that has been previously peeked by calling PeekNextFrame.
-   * If the peeked frame is a QoS Data frame, it is actually dequeued if it meets
-   * the constraint on the maximum A-MPDU size (by assuming that the frame has to
-   * be aggregated to an existing A-MPDU of the given size) and its transmission
-   * time does not exceed the given PPDU duration limit (if distinct from Time::Min ()).
-   * If the peeked frame is a unicast QoS Data frame stored in the EDCA queue,
-   * attempt to perform A-MSDU aggregation (while meeting the constraints mentioned
-   * above) if <i>aggregate</i> is true and assign a sequence number to the
-   * dequeued frame.
+   * Peek the next frame to transmit to the given receiver and of the given
+   * TID from the block ack manager retransmit queue first and, if not found, from
+   * the EDCA queue. If <i>tid</i> is equal to 8 (invalid value) and <i>recipient</i>
+   * is the broadcast address, the first available frame is returned.
+   * Note that A-MSDU aggregation is never attempted (this is relevant if the
+   * frame is peeked from the EDCA queue). If the frame is peeked from the EDCA
+   * queue, it is assigned a sequence number peeked from MacTxMiddle.
    *
-   * \param peekedItem the peeked frame.
-   * \param txVector the TX vector used to transmit the peeked frame
-   * \param aggregate whether to attempt A-MSDU aggregation
-   * \param ampduSize the size of the existing A-MPDU in bytes, if any
-   * \param ppduDurationLimit the limit on the PPDU duration
-   * \returns the dequeued frame.
+   * \param queueIt the QueueIteratorPair pointing to the queue item from which the
+   *                search for an MPDU starts, if the QueueIteratorPair is valid
+   * \param tid traffic ID.
+   * \param recipient the receiver station address.
+   * \returns the peeked frame.
    */
-  Ptr<WifiMacQueueItem> DequeuePeekedFrame (Ptr<const WifiMacQueueItem> peekedItem, WifiTxVector txVector,
-                                            bool aggregate = true, uint32_t ampduSize = 0,
-                                            Time ppduDurationLimit = Time::Min ());
-  /**
-   * Compute the MacLow transmission parameters for the given frame. Allowed frames
-   * are those handled by a QosTxop (QoS data frames, BlockAckReq frames, ADDBA
-   * Request/Response, DELBA Request).
+  Ptr<const WifiMacQueueItem> PeekNextMpdu (WifiMacQueueItem::QueueIteratorPair queueIt,
+                                            uint8_t tid = 8,
+                                            Mac48Address recipient = Mac48Address::GetBroadcast ());
+  /**
+   * Prepare the frame to transmit starting from the MPDU that has been previously
+   * peeked by calling PeekNextMpdu. A frame is only returned if it meets the
+   * constraint on the maximum A-MPDU size (by assuming that the frame has to be
+   * aggregated to an existing A-MPDU as specified by the TX parameters) and its
+   * transmission time does not exceed the given PPDU duration limit (if distinct from
+   *  Time::Min ()). If the peeked MPDU is a unicast QoS Data frame stored in the EDCA queue,
+   * attempt to perform A-MSDU aggregation (while meeting the constraints mentioned
+   * above) and assign a sequence number to the dequeued frame.
    *
-   * \param frame the given frame
-   * \return the MacLow transmission parameters.
+   * \param peekedItem the peeked frame.
+   * \param txParams the TX parameters for the frame
+   * \param availableTime the time available for the transmission of the frame
+                          (including protection and acknowledgment); a value of
+   *                      Time::Min() indicates no time constraint
+   * \param initialFrame true if the frame is the initial PPDU of a TXOP
+   * \param[out] queueIt a QueueIteratorPair pointing to the queue item following the
+   *                     last item used to prepare the returned MPDU, if any; if no MPDU
+   *                     is returned, its value is unchanged
+   * \return the frame to transmit or a null pointer if no frame meets the time constraints
    */
-  MacLowTransmissionParameters GetTransmissionParameters (Ptr<const WifiMacQueueItem> frame) const;
+  Ptr<WifiMacQueueItem> GetNextMpdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
+                                     Time availableTime, bool initialFrame,
+                                     WifiMacQueueItem::QueueIteratorPair& queueIt);
 
   /**
-   * Update the current packet this QosTxop is trying to transmit. This method
-   * is typically called by MacLow when it changes (i.e., by performing A-MSDU
-   * aggregation) the packet received from this QosTxop.
-   *
-   * \param mpdu the MPDU that MacLow is forwarding down to the PHY.
-   */
-  void UpdateCurrentPacket (Ptr<WifiMacQueueItem> mpdu);
-  /**
-   * The packet we sent was successfully received by the receiver.
+   * Assign a sequence number to the given MPDU, if it is not a fragment
+   * and it is not a retransmitted frame.
    *
-   * \param hdr the header of the packet that we successfully sent.
+   * \param mpdu the MPDU
    */
-  void BaTxOk (const WifiMacHeader &hdr);
+  void AssignSequenceNumber (Ptr<WifiMacQueueItem> mpdu) const;
+
   /**
-   * The packet we sent was successfully received by the receiver.
+   * Set the Queue Size subfield of the QoS Control field of the given QoS data frame.
    *
-   * \param hdr the header of the packet that we failed to sent.
+   * \param mpdu the given QoS data frame
    */
-  void BaTxFailed (const WifiMacHeader &hdr);
+  void SetQosQueueSize (Ptr<WifiMacQueueItem> mpdu);
 
   /**
-   * This functions are used only to correctly set source address in A-MSDU subframes.
-   * If aggregating STA is a non-AP STA (in an infrastructure network):
-   *   SA = Address2
-   * If aggregating STA is an AP
-   *   SA = Address3
+   * Return true if a TXOP has started.
    *
-   * \param hdr Wi-Fi header
-   * \return Mac48Address
+   * \return true if a TXOP has started, false otherwise.
    */
-  Mac48Address MapSrcAddressForAggregation (const WifiMacHeader &hdr);
+  virtual bool IsTxopStarted (void) const;
   /**
-   * This functions are used only to correctly set destination address in A-MSDU subframes.
-   * If aggregating STA is a non-AP STA (in an infrastructure network):
-   *   DA = Address3
-   * If aggregating STA is an AP
-   *   DA = Address1
+   * Return the remaining duration in the current TXOP.
    *
-   * \param hdr Wi-Fi header
-   * \return Mac48Address
+   * \return the remaining duration in the current TXOP.
    */
-  Mac48Address MapDestAddressForAggregation (const WifiMacHeader &hdr);
+  virtual Time GetRemainingTxop (void) const;
 
+protected:
+  void DoDispose (void) override;
 
 private:
   /// allow AggregationCapableTransmissionListener class access
   friend class AggregationCapableTransmissionListener;
 
-  // Overridden from Txop
-  void DoDispose (void);
-  void DoInitialize (void);
-  void TerminateTxop (void);
-  uint32_t GetNextFragmentSize (void) const;
-  uint32_t GetFragmentSize (void) const;
-  uint32_t GetFragmentOffset (void) const;
-  bool IsLastFragment (void) const;
+  void DoInitialize (void) override;
 
   /**
-   * If number of packets in the queue reaches m_blockAckThreshold value, an ADDBA Request frame
-   * is sent to destination in order to setup a block ack.
-   *
-   * \return true if we tried to set up block ack, false otherwise.
-   */
-  bool SetupBlockAckIfNeeded (void);
-  /**
-   * Sends an ADDBA Request to establish a block ack agreement with STA
-   * addressed by <i>recipient</i> for TID <i>tid</i>.
-   *
-   * \param recipient address of the recipient.
-   * \param tid traffic ID.
-   * \param startSeq starting sequence.
-   * \param timeout timeout value.
-   * \param immediateBAck flag to indicate whether immediate BlockAck is used.
-   */
-  void SendAddBaRequest (Mac48Address recipient, uint8_t tid, uint16_t startSeq,
-                         uint16_t timeout, bool immediateBAck);
-  /**
    * Check if the given MPDU is to be considered old according to the current
    * starting sequence number of the transmit window, provided that a block ack
    * agreement has been established with the recipient for the given TID.
@@ -480,68 +407,17 @@
    */
   bool IsQosOldPacket (Ptr<const WifiMacQueueItem> mpdu);
 
-  /**
-   * Check if the current packet is fragmented because of an exceeded TXOP duration.
-   *
-   * \return true if the current packet is fragmented because of an exceeded TXOP duration,
-   *         false otherwise
-   */
-  bool IsTxopFragmentation (void) const;
-  /**
-   * Calculate the size of the current TXOP fragment.
-   *
-   * \return the size of the current TXOP fragment in bytes
-   */
-  uint32_t GetTxopFragmentSize (void) const;
-  /**
-   * Calculate the number of TXOP fragments needed for the transmission of the current packet.
-   *
-   * \return the number of TXOP fragments needed for the transmission of the current packet
-   */
-  uint32_t GetNTxopFragment (void) const;
-  /**
-   * Calculate the size of the next TXOP fragment.
-   *
-   * \param fragmentNumber number of the next fragment
-   * \returns the next TXOP fragment size in bytes
-   */
-  uint32_t GetNextTxopFragmentSize (uint32_t fragmentNumber) const;
-  /**
-   * Calculate the offset for the fragment.
-   *
-   * \param fragmentNumber number of the fragment
-   * \returns the TXOP fragment offset in bytes
-   */
-  uint32_t GetTxopFragmentOffset (uint32_t fragmentNumber) const;
-  /**
-   * Callback when ADDBA response is not received after timeout.
-   *
-   * \param recipient MAC address of recipient
-   * \param tid traffic ID
-   */
-  void AddBaResponseTimeout (Mac48Address recipient, uint8_t tid);
-  /**
-   * Reset BA agreement after BA negotiation failed.
-   *
-   * \param recipient MAC address of recipient
-   * \param tid traffic ID
-   */
-  void ResetBa (Mac48Address recipient, uint8_t tid);
-
   AcIndex m_ac;                                         //!< the access category
-  TypeOfStation m_typeOfStation;                        //!< the type of station
-  Ptr<WifiAckPolicySelector> m_ackPolicySelector;       //!< the ack policy selector
+  Ptr<QosFrameExchangeManager> m_qosFem;                //!< the QoS Frame Exchange Manager
   Ptr<QosBlockedDestinations> m_qosBlockedDestinations; //!< the QoS blocked destinations
   Ptr<BlockAckManager> m_baManager;                     //!< the block ack manager
   uint8_t m_blockAckThreshold;                          /**< the block ack threshold (use BA mechanism if number of packets in queue reaches
                                                              this value. If this value is 0, block ack is never used. When A-MPDU is enabled,
                                                              block ack mechanism is used regardless of this value) */
-  BlockAckType m_blockAckType;                          //!< the BlockAck type
   Time m_currentPacketTimestamp;                        //!< the current packet timestamp
   uint16_t m_blockAckInactivityTimeout;                 //!< the BlockAck inactivity timeout value (in TUs, i.e. blocks of 1024 microseconds)
   Time m_startTxop;                                     //!< the start TXOP time
-  bool m_isAccessRequestedForRts;                       //!< flag whether access is requested to transmit a RTS frame
-  bool m_currentIsFragmented;                           //!< flag whether current packet is fragmented
+  Time m_txopDuration;                                  //!< the duration of a TXOP
   Time m_addBaResponseTimeout;                          //!< timeout for ADDBA response
   Time m_failedAddBaTimeout;                            //!< timeout after failed BA agreement
   bool m_useExplicitBarAfterMissedBlockAck;             //!< flag whether explicit BlockAckRequest should be sent upon missed BlockAck Response
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/qos-utils.cc ns-3.34/src/wifi/model/qos-utils.cc
--- ns-3.33/src/wifi/model/qos-utils.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/qos-utils.cc	2021-07-14 10:31:07.000000000 -0700
@@ -28,6 +28,100 @@
 
 namespace ns3 {
 
+std::size_t
+WifiAddressTidHash::operator()(const WifiAddressTidPair& addressTidPair) const
+{
+  uint8_t buffer[7];
+  addressTidPair.first.CopyTo (buffer);
+  buffer[6] = addressTidPair.second;
+
+  std::string s (buffer, buffer + 7);
+  return std::hash<std::string>{} (s);
+}
+
+std::size_t
+WifiAddressHash::operator()(const Mac48Address& address) const
+{
+  uint8_t buffer[6];
+  address.CopyTo (buffer);
+
+  std::string s (buffer, buffer + 6);
+  return std::hash<std::string>{} (s);
+}
+
+WifiAc::WifiAc (uint8_t lowTid, uint8_t highTid)
+  : m_lowTid (lowTid),
+    m_highTid (highTid)
+{
+}
+
+uint8_t
+WifiAc::GetLowTid (void) const
+{
+  return m_lowTid;
+}
+
+uint8_t
+WifiAc::GetHighTid (void) const
+{
+  return m_highTid;
+}
+
+uint8_t
+WifiAc::GetOtherTid (uint8_t tid) const
+{
+  if (tid == m_lowTid)
+    {
+      return m_highTid;
+    }
+  if (tid == m_highTid)
+    {
+      return m_lowTid;
+    }
+  NS_ABORT_MSG ("TID " << tid << " does not belong to this AC");
+}
+
+bool operator> (enum AcIndex left, enum AcIndex right)
+{
+  NS_ABORT_MSG_IF (left > 3 || right > 3, "Cannot compare non-QoS ACs");
+
+  if (left == right)
+    {
+      return false;
+    }
+  if (left == AC_BK)
+    {
+      return false;
+    }
+  if (right == AC_BK)
+    {
+      return true;
+    }
+  return static_cast<uint8_t> (left) > static_cast<uint8_t> (right);
+}
+
+bool operator>= (enum AcIndex left, enum AcIndex right)
+{
+  NS_ABORT_MSG_IF (left > 3 || right > 3, "Cannot compare non-QoS ACs");
+
+  return (left == right || left > right);
+}
+
+bool operator< (enum AcIndex left, enum AcIndex right)
+{
+  return !(left >= right);
+}
+
+bool operator<= (enum AcIndex left, enum AcIndex right)
+{
+  return !(left > right);
+}
+
+const std::map<AcIndex, WifiAc> wifiAcList = { {AC_BE, {0, 3}},
+                                               {AC_BK, {1, 2}},
+                                               {AC_VI, {4, 5}},
+                                               {AC_VO, {6, 7}} };
+
 AcIndex
 QosUtilsMapTidToAc (uint8_t tid)
 {
@@ -89,12 +183,6 @@
   return (distance >= 2048);
 }
 
-/**
- *  \brief Extraction operator for TypeId
- *  \param [in] packet is the packet
- *  \param [in] hdr is Wifi MAC header
- *  \returns the TypeId of the MAC header
- */
 uint8_t
 GetTid (Ptr<const Packet> packet, const WifiMacHeader hdr)
 {
